﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using ResoursesManager.Models;
using ResoursesManager.ViewModels;
using System.Data.Entity.Core.Objects;

namespace ResoursesManager.Controllers
{
    public class StatisticsController : Controller
    {
        private ApplicationDbContext db = new ApplicationDbContext();

        // GET: Statistics
        public ActionResult Index(StatisticType? byTypeType, int? byResourceId, SubscribeType? subscribeType, int? subscribeId)
        {
            if (byTypeType == null)
            {
                byTypeType = StatisticType.Reserv;
            }
            if (byResourceId == null)
            {
                byResourceId = db.Resources.FirstOrDefault().Id;
            }
            if (subscribeType == null)
            {
                subscribeType = SubscribeType.ByUser;
            }
            if (subscribeId == null)
            {
                subscribeId = db.Resources.FirstOrDefault().Id;
            }
            var model = new StatisticViewModel()
            {
                Log = db.Statistic.ToList()
            };
            model.ByType = db.Statistic.Where(k => k.StatisticType == byTypeType /*&& k.DateTime > DateTime.Today.AddDays(-30.0)*/).GroupBy(l => DbFunctions.TruncateTime(l.DateTime)).ToDictionary(j => (DateTime)j.Key, j => j.Count());
            model.ByResource = db.Statistic.Where(k => k.ResourceId == byResourceId /*&& k.DateTime > DateTime.Today.AddDays(-30.0)*/).GroupBy(l => l.ResourceId).ToDictionary(j => j.Key, j => j.Count());
            model.ByTypeCircle = db.Statistic.GroupBy(l => l.StatisticType).ToDictionary(j => j.Key, j => j.Count());
            var subscibedUser = db.Resources.FirstOrDefault(k => k.Id == subscribeId).Users.Count;
            var allUsers = db.Users.Count();
            model.Subscribe = new Dictionary<string, int>();
            model.Subscribe.Add("Subscribed user", subscibedUser);
            model.Subscribe.Add("Unsubscibed user", allUsers - subscibedUser);



            return View(model);
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}
